package org.breezesoft.listviewexample;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import android.app.Activity;
import android.content.Context;
import android.os.Bundle;
import android.view.ContextMenu;
import android.view.ContextMenu.ContextMenuInfo;
import android.view.LayoutInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.AdapterContextMenuInfo;
import android.widget.BaseAdapter;
import android.widget.CheckBox;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

public class ListViewExampleActivity extends Activity {

	private String items[];
	private int colors[];
	private boolean checkboxstate[];
	private ListView listView;
	private List<Map<String, Object>> itemList;
	private ItemAdapter itemListAdapter;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);

		String item = "Red\nGreen\nBlue";
		items = item.split("\n");
		colors=new int[3];
		colors[0]=R.drawable.red;
		colors[1]=R.drawable.green;
		colors[2]=R.drawable.blue;
		checkboxstate=new boolean[3];
		checkboxstate[0]=false;
		checkboxstate[1]=false;
		checkboxstate[2]=false;
		
		
		
		refresh();

		listView.setOnItemClickListener(new AdapterView.OnItemClickListener() {
			@Override
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
				;
			}
		});

	}

	@Override
	public void onResume() {
		super.onResume();
		refresh();
	}

	@Override
	public void onPause() {
		super.onPause();
	}

	@Override
	public void onStop() {
		super.onStop();
	}

	@Override
	public void onCreateContextMenu(ContextMenu menu, View view, ContextMenuInfo menuInfo) {
		menu.setHeaderTitle(R.string.app_name);
		menu.add(0, 1, 0, R.string.app_name);
		menu.add(0, 2, 0, R.string.app_name);
	}

	@Override
	public boolean onContextItemSelected(MenuItem item) {
		AdapterContextMenuInfo info = (AdapterContextMenuInfo) item.getMenuInfo();
		switch (item.getItemId()) {
		case 1:
			break;
		case 2:
			break;
		}
		return true;

	}

	private void refresh() {
		listView = new ListView(this);
		listView = (ListView) findViewById(R.id.list1);

		itemList = new ArrayList<Map<String, Object>>();
		for (int i = 0; i < items.length; i++) {
			Map<String, Object> map = new HashMap<String, Object>();
			map.put("IMG", colors[i]);
			map.put("ITEMNAME", items[i]);
			if (checkboxstate[i]) {
				map.put("CHECKED", "t");
			} else {
				map.put("CHECKED", "f");
			}
			itemList.add(map);
		}
		itemListAdapter = new ItemAdapter(this, itemList);
		listView.setAdapter(itemListAdapter);
	}

	public void setC(int position) {
		if (checkboxstate[position]) {
			checkboxstate[position] = false;
		} else
			checkboxstate[position] = true;
	}

	public class ItemAdapter extends BaseAdapter {
		private List<Map<String, Object>> itemList;
		private LayoutInflater mInflater;

		public ItemAdapter(Context context, List<Map<String, Object>> til) {
			this.mInflater = LayoutInflater.from(context);
			itemList = til;
		}

		public int getCount() {
			return itemList.size();
		}

		public Object getItem(int arg0) {
			return null;
		}

		public long getItemId(int arg0) {
			return 0;
		}

		public View getView(int position, View convertView, ViewGroup parent) {
			final int cc = position;
			ViewHolder holder = null;
			if (convertView == null) {
				holder = new ViewHolder();
				convertView = mInflater.inflate(R.layout.itemrow, null);
				holder.tagcolor = (ImageView) convertView.findViewById(R.id.itemrowiamge);
				holder.itemname = (TextView) convertView.findViewById(R.id.itemrowtext);
				holder.cb = (CheckBox) convertView.findViewById(R.id.itemrowcb);
				convertView.setTag(holder);
			} else {
				holder = (ViewHolder) convertView.getTag();
			}

			holder.tagcolor.setBackgroundResource((Integer) itemList.get(position).get("IMG"));
			holder.itemname.setText((String) itemList.get(position).get("ITEMNAME"));
			holder.ckd = (String) itemList.get(position).get("CHECKED");

			holder.cb.setOnClickListener(new View.OnClickListener() {
				public void onClick(View v) {
					setC(cc);
				}
			});
			if (holder.ckd.equals("t"))
				holder.cb.setChecked(true);
			else
				holder.cb.setChecked(false);
			return convertView;
		}
	}

}